
declare sub savePos
declare function loadPos as boolean
declare function posToStr(byval p as position) as string
declare sub strToPos(byval s as string)

sub savePos
  dim as uByte ff = freeFile
  dim erreur as integer = open("Position.txt" for output as #ff)
  if erreur = 0 then
    print #ff, posToStr(courante)
    print #ff, sGame;
    close #ff
  else
    rem
  end if
end sub

function loadPos as boolean
  dim as uByte ff = freeFile
  dim as integer erreur = open("Position.txt" for input as #ff)
  dim as string s
  if erreur = 0 then
    line input #ff, s
    line input #ff, sGame
    close #ff
    strToPos(s)
    return vrai
  else
    return faux
  end if
end function

function posToStr(byval p as position) as string
  '
  rem Forsyth-Edwards notation
  '
  dim as string chaineFEN = ""
  dim as string PP' Piece Placement
  dim as string AC' Active Color
  dim as string CA' Castling Availability
  dim as string TS' En Passant Target Square
  dim as string HC' Halfmove Clock
  dim as string FN' Fullmove Number
  dim as byte x, y, n = 0
  '
  PP = ""
  for y = 7 to 0 step -1
    for x = 0 to 7
      select case p.damier(x, y)
      case roi * noir
        PP += "k"
      case dame * noir
        PP += "q"
      case tour * noir
        PP += "r"
      case fou * noir
        PP += "b"
      case cavalier * noir
        PP += "n"
      case pion * noir
        PP += "p"
      case neant
        n += 1
        if x = 7 then
          PP += str(n)
          n = 0
        else
          if p.damier(x + 1, y) <> neant then
            PP += str(n)
            n = 0
          end if
        end if
      case pion * blanc
        PP += "P"
      case cavalier * blanc
        PP += "N"
      case fou * blanc
        PP += "B"
      case tour * blanc
        PP += "R"
      case dame * blanc
        PP += "Q"
      case roi * blanc
        PP += "K"
      end select
    next x
    if y > 0 then PP += "/"
  next y
  chaineFEN += PP & chr(32)
  '
  AC = ""
  select case p.trait
  case blanc
    AC = "w"
  case noir
    AC = "b"
  end select
  chaineFEN += AC & chr(32)
  '
  CA = ""
  if p.roque(e1g1)=Vrai then CA += "K"
  if p.roque(e1c1)=Vrai then CA += "Q"
  if p.roque(e8g8)=Vrai then CA += "k"
  if p.roque(e8c8)=Vrai then CA += "q"
  if len(CA) = 0 then CA = "-"
  chaineFEN += CA & chr(32)
  '
  TS = ""
  if p.passant = 8 then
    TS = "-"
  else
    if p.trait = blanc then
      rem y = 2
      TS = chr(97 + p.passant) & chr(49 + 2)
    else
      rem y = 5
      TS = chr(97 + p.passant) & chr(49 + 5)
    end if
  end if
  chaineFEN += TS & chr(32)
  '
  HC = str(p.demiCoups)
  chaineFEN += HC & chr(32)
  '
  FN = str(p.pli)
  chaineFEN += FN
  '
  return chaineFEN
  '
end function

/' memento
sub initialiseJeu
  restore
  for y as byte = 7 to 0 step -1
    for x as byte = 0 to 7
      read initiale(x, y)
      courante.damier(x, y) = initiale(x, y)
    next x
  next y
  courante.trait = blanc
  courante.roque(e8c8) = vrai
  courante.roque(e8g8) = vrai
  courante.roque(e1c1) = vrai
  courante.roque(e1g1) = vrai
  courante.passant = 8
  courante.demiCoups = 0
  courante.pli = 1
end sub'/

sub strToPos(byval s as string)
  '
  dim as byte i, j, n, x, y
  '
  i = 1' index chane FEN
  n = 0' 0  63
  do
    select case mid(s, i, 1)
    case "k"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = - roi
      i += 1
      n += 1
    case "q"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = - dame
      i += 1
      n += 1
    case "r"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = - tour
      i += 1
      n += 1
    case "b"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = - fou
      i += 1
      n += 1
    case "n"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = - cavalier
      i += 1
      n += 1
    case "p"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = - pion
      i += 1
      n += 1
    case "P"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = + pion
      i += 1
      n += 1
    case "N"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = + cavalier
      i += 1
      n += 1
    case "B"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = + fou
      i += 1
      n += 1
    case "R"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = + tour
      i += 1
      n += 1
    case "Q"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = + dame
      i += 1
      n += 1
    case "K"
      y = 8 - n \ 8
      x = n + 1 - 8 * (8 - y)
      courante.damier(x - 1, y - 1) = + roi
      i += 1
      n += 1
    case "1" to "8"
      for j = 1 to valint(mid(s, i, 1))
        y = 8 - n \ 8
        x = n + 1 - 8 * (8 - y)
        courante.damier(x - 1, y - 1) = neant
        n += 1
      next j
      i += 1
    case "/"
      i += 1
    end select
  loop until n = 64
  '
  i += 1
  select case mid(s, i, 1)
  case "w"
    courante.trait = blanc
    i += 1
  case "b"
    courante.trait = noir
    i += 1
  end select
  '
  i += 1
  if mid(s, i, 1) = "K" then
    courante.roque(e1g1) = vrai
    i += 1
  end if
  if mid(s, i, 1) = "Q" then
    courante.roque(e1c1) = vrai
    i += 1
  end if
  if mid(s, i, 1) = "k" then
    courante.roque(e8g8) = vrai
    i += 1
  end if
  if mid(s, i, 1) = "q" then
    courante.roque(e8c8) = vrai
    i += 1
  end if
  if mid(s, i, 1) = "-" then
    for j = e8c8 to e1g1
      courante.roque(j) = faux
    next j
    i += 1
  end if
  '
  i += 1
  if mid(s, i, 1) = "-" then
    courante.passant = 8
    i += 1
  else
    courante.passant = s[i] - 97
    i += 2
  end if
  '
  i += 1
  j = 0
  do
    j += 1
  loop until mid(s, i + j, 1) = chr(32)
  courante.demiCoups = valint(mid(s, i, j))
  '
  i += 1
  j = 0
  do
    j += 1
  loop until mid(s, i + j, 1) = chr(32)
  '
  courante.pli = valint(mid(s, i, j))
end sub
