
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
'
'  Eschecs-FB version 0.8.4
'
'  Essai d'un programme de jeu d'checs par Roland Chastain
'
'  Compilation FreeBASIC 0.23.0
'
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#DEFINE DEV
#UNDEF  DEV

#include "mdLanguage\mdLanguage.bi"

#include "sGUI\sGUI.bas"
#include "sGUI\SimpleGadget.bas"
#include "sGUI\StringGadget.bas"
#include "sGUI\MessageBox.bas"
#include "sGUI\ClickMapGadget.bas"
#include "sGUI\ToggleGadget.bas"

#include "Chess.bas"
#include "Files.bas"

dim as EventHandle ptr event
dim as Gadget ptr textedit
dim as Gadget ptr button1, button2, button3, button4, button5, button6
dim as Gadget ptr boardClickSensor
dim as Gadget ptr toggle

declare function inspection(s as string) as string
declare sub fin(u as ubyte)
declare sub info(s as string)
declare sub canevas
declare sub jeu(chaineCoupLegal as string)
declare sub coupOrdinateur

dim langue as string*2
dim as uByte fichier
dim as integer erreur_fichier
fichier = freeFile
erreur_fichier = open("Language.ini" for input as #fichier)
if erreur_fichier = 0 then
  line input #fichier, langue
  close #fichier
else
  langue = "en"
end if
loadCustomLanguage(default, langue, "language/")
#include "Help.bas"

screenres 560, 400, 32,, 4
windowtitle "ESCHECS"
#undef Black
#undef White
#include "Colors.bi"
#include "Colors.bas"
#include "Board.bas"
width 560\8, 400\16
InitGFX

event=CreateEventHandle

button1=AddSimpleGadget(event,400,076,120,24,getTranslation(default,"button1"))
button2=AddSimpleGadget(event,400,112,120,24,getTranslation(default,"button2"))
button3=AddSimpleGadget(event,400,184,120,24,getTranslation(default,"button3"))
button4=AddSimpleGadget(event,400,220,120,24,getTranslation(default,"button4"))
button5=AddSimpleGadget(event,400,256,120,24,getTranslation(default,"button5"))
button6=AddSimpleGadget(event,400,292,120,24,getTranslation(default,"button6"))

textedit=AddStringGadget(event,400,328,14,"",,,1)
boardClickSensor=AddClickMapGadget(event,40,40,"ClickMap.bmp")
toggle=AddToggleGadget(event,400,148,120,24,0,getTranslation(default,"toggle"))

GadgetOn(button1,toggle)

initialiseJeu
initialiseImages
dessineTablier(40,40)
info("")

dim as integer field_ID

type chessfield 
  fieldname as string 
  selected as integer 
  posx as integer 
  posy as integer 
end type

dim as chessfield Board (1 to 64)

for k as integer= 0 to 7 
  Board(1 + k*8).fieldname="a" & str(k+1) 
  Board(2 + k*8).fieldname="b" & str(k+1) 
  Board(3 + k*8).fieldname="c" & str(k+1) 
  Board(4 + k*8).fieldname="d" & str(k+1) 
  Board(5 + k*8).fieldname="e" & str(k+1) 
  Board(6 + k*8).fieldname="f" & str(k+1) 
  Board(7 + k*8).fieldname="g" & str(k+1) 
  Board(8 + k*8).fieldname="h" & str(k+1) 
next k 

dim sInput as string
dim shared cComputer as coup
dim shared no_reply as boolean = faux

do
  '
  event->xSleep(1)
  '
  if event->GADGETMESSAGE then
    '
    select case event->GADGETMESSAGE
    '
    case textedit
      '
      sInput = GetString(textedit)
      '
      SetString(textedit, "")
      '
      GadgetSleep(textedit)
      '
      sInput = lCase(sInput)
      '
      select case inspection(sInput)
      '
      case "legal"
        '
        jeu(sInput)
        '
      case "known"
        '
        select case sInput
        '
        case "exit"
          '
          fin(3)
          '
          event->EXITEVENT = 1
          '
        case "play"
          '
          coupOrdinateur
          '
        end select
        '
      case "illegal_or_unknown"
        '
        rem
        '
      end select
      '
      GadgetOn(textedit)
      '
      sInput = ""
      '
    case button1
      '
      info("")
      '
      initialiseJeu
      '
      dessineTablier(40,40)
      '
    case button2
      '
      coupOrdinateur
      '
    case button3
      '
      savePos
      '
    case button4
      '
      info("")
      '
      if loadPos then
        dessineTablier(40,40)
      else
        info(getTranslation(default, "error"))
      end if
      '
    case button5
      '
      messageBox(50,50,help,getTranslation(default,"button5"),MBType_OK)
      '
    case button6
      '
      fin(3)
      '
      event->EXITEVENT = 1
      '
    case boardClickSensor
      '
      field_ID = getClickMapColor(boardClickSensor)
      '
      sInput = sInput & Board(field_ID).fieldname
      '
      info(sInput)
      '
      if len(sInput) = 4 then
        '
        if inspection(sInput) = "legal" then
          '
          jeu(sInput)
          '
        else
          '
          info("")
          '
        end if
        '
        sInput = ""
        '
      end if
      '
      case toggle
        '
        if GetSelect(toggle) then
          no_reply = vrai
        else
          no_reply = faux
        end if
        '
    end select
    '
  end if
  '
loop until event->EXITEVENT

destroyEventHandle (event)
end

function inspection(s as string) as string
  '
  if len(s) = 4 _
  andalso (inStr(possibles(courante), s) mod 4 = 1) _
  and (courante.demiCoups < 50) _
  then
    '
    return "legal"
    '
  else
    '
    if len(s) = 4 _
    andalso (s = "exit") or (s = "play") then
      '
      return "known"
      '
    else
      '
      return "illegal_or_unknown"
      '
    end if
    '
  end if
  '
end function

sub fin(u as ubyte)
  '
  dim as string game_result
  '
  if u = 3 then
    '
    game_result = ""
    '
  else
    '
    if possibles(courante) = "" then
      '
      if echec(courante) then
        '
        if courante.trait = blanc then
          '
          game_result = "1 - 0"
          '
        else
          '
          game_result = "0 - 1"
          '
        end if
        '
      else
        '
        game_result = "0 - 0"
        '
      end if
      '
    else
      '
      game_result = "0 - 0"
      '
    end if
    '
  end if
  '
  info(game_result)
  '
  dim as string msg, title
  '
  select case as const u
  case 1' Partie termine par un coup de l'utilisateur
    msg = getTranslation(default, "message1")
  case 2' Partie termine par un coup de l'ordinateur
    msg = getTranslation(default, "message2")
  case 3' Partie interrompue
    msg = getTranslation(default, "message3")
  end select
  '
  title = getTranslation(default, "messagetitle")
  '
  messageBox(50, 296, msg, title, MBType_OK)
  '
end sub

sub info(s as string)
  '
  FillA(400, 40, 120, fontheight + 8, BackgroundColor, 1)
  '
  draw string(403, 44), space((14 - len(s)) \ 2) + s, TextColor
  '
end sub

sub jeu(chaineCoupLegal as string)
  '
  dim monCoup as coup
  '
  strToCoup(chaineCoupLegal, monCoup)
  '
  sGame = sGame & chaineCoupLegal
  '
  mouvement(monCoup, courante)
  '
  dessineTablier(40,40)
  '
  if (possibles(courante) = "") or (courante.demiCoups = 50) then
    '
    fin(1)
    '
  else
    '
    if not no_reply then coupOrdinateur
    '
  end if
  '
end sub

sub coupOrdinateur
  '
  cComputer = meilleurCoup
  '
  if  (cComputer.x1 = 0) _
  and (cComputer.y1 = 0) _
  and (cComputer.x2 = 0) _
  and (cComputer.y2 = 0) _
  then exit sub
  '
  sGame = sGame & coupToStr(cComputer)
  '
  mouvement(cComputer, courante)
  '
  info(coupToStr(cComputer))
  '
  dessineTablier(40, 40)
  '
  if (possibles(courante) = "") or (courante.demiCoups = 50) then
    '
    fin(2)
    '
  end if
  '
end sub
